package com.plugin.GCM;


//import java.io.*;
//import java.util.*;


import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import android.util.Log;

import org.apache.cordova.api.Plugin;
import org.apache.cordova.api.PluginResult;
import org.apache.cordova.api.PluginResult.Status;
import com.google.android.gcm.*;


/**
 * @author awysocki
 *
 */

public class GCMPlugin extends Plugin {

  public static final String ME="GCMPlugin";

  public static final String REGISTER="register";
  public static final String UNREGISTER="unregister";

  public static Plugin gwebView;
  private static String gECB;
  private static String gSenderID;

  @Override
  public PluginResult execute(String action, JSONArray data, String callbackId)
  {

    PluginResult result = null;

    Log.v(ME + ":execute", "action=" + action);

    if (REGISTER.equals(action)) {

      Log.v(ME + ":execute", "data=" + data.toString());

      try {

        JSONObject jo= new JSONObject(data.toString().substring(1, data.toString().length()-1));

        gwebView = this;

        Log.v(ME + ":execute", "jo=" + jo.toString());

        gECB = (String)jo.get("ecb");
        gSenderID = (String)jo.get("senderID");

        Log.v(ME + ":execute", "ECB="+gECB+" senderID="+gSenderID );

        Log.v(ME + ":execute", "Checking device");
        GCMRegistrar.checkDevice(this.cordova.getActivity().getApplicationContext());
        Log.v(ME + ":execute", "Checking manifest");
        GCMRegistrar.checkManifest(this.cordova.getActivity().getApplicationContext());
        
        final String regId = GCMRegistrar.getRegistrationId(this.cordova.getActivity().getApplicationContext());
        if (regId.equals("")) {
            GCMRegistrar.register(this.cordova.getActivity().getApplicationContext(), gSenderID);
            result = new PluginResult(Status.OK);
        } else {
        	Log.v(ME + ":execute", "App already registered");
        	result = new PluginResult(Status.OK, "ALREADY REGISTERED");
        }
        


        Log.v(ME + ":execute", "GCMRegistrar.register called ");

        
      }
      catch (JSONException e) {
        Log.e(ME, "Got JSON Exception "
          + e.getMessage());
        result = new PluginResult(Status.JSON_EXCEPTION);
      }
    }
    else if (UNREGISTER.equals(action)) {

      GCMRegistrar.unregister(this.cordova.getActivity().getApplicationContext());
      Log.v(ME + ":" + UNREGISTER, "GCMRegistrar.unregister called ");
      result = new PluginResult(Status.OK);

    }
    else
    {
      result = new PluginResult(Status.INVALID_ACTION);
      Log.e(ME, "Invalid action : "+action);
    }

    return result;
  }


  public static boolean sendJavascript( JSONObject _json )
  {
    String _d =  "javascript:"+gECB+"(" + _json.toString() + ")";
        Log.v(ME + ":sendJavascript", _d);
        if (gECB!=null){
        	gwebView.sendJavascript( _d );
        	return true;
        }
        return false;
  }


  /**
   * Gets the Directory listing for file, in JSON format
   * @param file The file for which we want to do directory listing
   * @return JSONObject representation of directory list. e.g {"filename":"/sdcard","isdir":true,"children":[{"filename":"a.txt","isdir":false},{..}]}
   * @throws JSONException
   */


}
